<?php
/***************************************************************************
*                                                                          *
*                                                                          *
*                   All rights reserved! CS-Cart.co.il                     *
*                                                                          *
*                                                                          *
****************************************************************************/

use Tygh\Registry;

if (!defined('BOOTSTRAP')) { die('Access denied'); }

function fn_settings_variants_addons_icredit_order_status()
{
	$statuses = fn_get_statuses('O', array(), false, false, DESCR_SL);

	$result = array();
	$result[''] = __('please_select_one');
	foreach ($statuses as $k => $s) {
		$result[$s['status']] = $s['description'];
	}
	
	return $result;
}

function fn_settings_variants_addons_icredit_id_number()
{
	return fn_icredit_build_pfields();
}

function fn_settings_variants_addons_icredit_vat_number()
{
	return fn_icredit_build_pfields();
}

function fn_icredit_install()
{
    $payments = fn_get_schema('payments', 'processors', 'php', true);

    if (!empty($payments)) {
        foreach ($payments as $payment) {

            $processor_id = db_get_field("SELECT processor_id FROM ?:payment_processors WHERE admin_template = ?s", $payment['admin_template']);

            if (empty($processor_id)) {
                db_query('INSERT INTO ?:payment_processors ?e', $payment);
            } else {
                db_query("UPDATE ?:payment_processors SET ?u WHERE processor_id = ?i", $payment, $processor_id);
            }
        }
    }
}

function fn_icredit_uninstall()
{
    $payments = fn_get_schema('payments', 'processors');

    foreach ($payments as $payment) {
        db_query("DELETE FROM ?:payment_processors WHERE admin_template = ?s", $payment['admin_template']);
    }
}

/**
*
* HOOKS
*
**/


/**
*
* UTILITY
*
**/
function fn_icredit_build_pfields()
{
	$profile_fields = fn_get_profile_fields('ALL', array(), DESCR_SL);

	$data = array();
	$data[''] = __('please_select_one');

	foreach ($profile_fields as $section => $fields) {
		if ($section == 'E') {
			continue;
		} elseif ($section == 'C') {
			$data['C'] = '-- '.__('contact_information').' --';
		} elseif ($section == 'B') {
			$data['B'] = '-- '.__('billing_address').' --';
		} elseif ($section == 'S') {
			$data['S'] = '-- '.__('shipping_address').' --';
		}
		foreach ($fields as $k => $f) {
			$data[$f['field_id']] = $f['description'];
		}
	}
	
	return $data;
}