<?php
/***************************************************************************
*                                                                          *
*                                                                          *
*                   All rights reserved! CS-Cart.co.il                     *
*                                                                          *
*                                                                          *
****************************************************************************/

use Tygh\Registry;
use Tygh\Http;
use Tygh\Session;

if (!defined('BOOTSTRAP')) { die('Access denied'); }

$icredit = Registry::get('addons.icredit');

if (defined('PAYMENT_NOTIFICATION')) {

	$pp_response = array();
	$order_id = $_REQUEST['order_id'];
	
	if ($mode == 'finish') {
		$pp_response['transaction_id'] = $_REQUEST['Token'];
		if (!empty($_REQUEST['Token'])) {
			$pp_response['order_status'] = $icredit['order_status'];
			$pp_response['reason_text'] = __('completed');
		} else {
			$pp_response['order_status'] = 'F';
			$pp_response['reason_text'] = __('error');
		}
	}
	
	fn_finish_payment($order_id, $pp_response);
	if (empty($_REQUEST['iframe_mode'])) {
		fn_order_placement_routines('route', $order_id);
	} else {
		$_error = false;
		$url = fn_url('checkout.cart');
		$order_link = '';
		
		if ($pp_response['order_status'] == $icredit['order_status']) {
			$type = 'N';
			$url = fn_url('checkout.complete');
			$order_link_url = fn_url('orders.details?order_id='.$order_id);
			
		} elseif ($pp_response['order_status'] == 'F') {
			$type = 'E';
			$_error = true;

		}
		
		if ($_error == false) {
			$_SESSION['cart'] = array(
                'user_data' => !empty($_SESSION['cart']['user_data']) ? $_SESSION['cart']['user_data'] : array(),
                'profile_id' => !empty($_SESSION['cart']['profile_id']) ? $_SESSION['cart']['profile_id'] : 0,
                'user_id' => !empty($_SESSION['cart']['user_id']) ? $_SESSION['cart']['user_id'] : 0,
            );
            $_SESSION['shipping_rates'] = array();
            unset($_SESSION['shipping_hash']);

            db_query('DELETE FROM ?:user_session_products WHERE session_id = ?s AND type = ?s', Session::getId(), 'C');
		}
		$notification = $pp_response['reason_text'] . '. ' . __('icredit.order_complete', array(
			'[order_link]' => $order_link_url,
			'[order_details]' => __('order_details')
		));
		fn_set_notification($type, '', $notification , 'S');
		
		Tygh::$app['view']->assign('url', $url);
		Tygh::$app['view']->assign('_error', $_error);
		Tygh::$app['view']->assign('reason_text', $pp_response['reason_text']);
		Tygh::$app['view']->display('addons/icredit/views/orders/components/payments/icredit.tpl');
		fn_flush();
		exit;
	}

} else {
	$iframe = '';
	if (defined('IFRAME_MODE')) {
		list($order_id, $process_payment) = fn_place_order($_SESSION['cart'], $_SESSION['auth']);
		$_order_info = $_SESSION['cart'];
		$data = array (
			'order_id' => $order_id,
			'type' => 'S',
			'data' => TIME,
		);
		db_query('REPLACE INTO ?:order_data ?e', $data);
		$iframe = "&iframe_mode=true";
	}
	
	$url = ($processor_data['processor_params']['test'] == 'Y') ? 'https://testicredit.rivhit.co.il/API/PaymentPageRequest.svc/GetUrl' : 'https://icredit.rivhit.co.il/API/PaymentPageRequest.svc/GetUrl';
	$id_number = $icredit['id_number'];
	$vat_number = $icredit['vat_number'];
	$redirect_url = fn_url("payment_notification.finish?payment=icredit&order_id=".$order_id . $iframe, AREA, 'current');

	$post = array(
		'GroupPrivateToken' => $processor_data['processor_params']['GroupPrivateToken'],
		'CustomerLastName' => !empty($order_info['lastname']) ? $order_info['lastname'] : $order_info['s_lastname'],
		'CustomerFirstName' => !empty($order_info['firstname']) ? $order_info['firstname'] : $order_info['s_firstname'],
		'EmailAddress' => $order_info['email'],
		'Address' => $order_info['s_address'],
		'City' => $order_info['s_city'],
		'POB' => 0,
		'PhoneNumber' => !empty($order_info['phone']) ? $order_info['phone'] : $order_info['s_phone'],
		'PhoneNumber2' => '',
		'FaxNumber' => !empty($order_info['fax']) ? $order_info['fax'] : '',
		'Comments' => '',
		'Custom1' => $order_id,
		'RedirectURL' => $redirect_url
	);
	if ($order_info['s_country'] == 'IL') {
		$post['Zipcode'] = $order_info['s_zipcode'];
		$post['IdNumber'] = $order_info['fields'][$id_number];
		$post['VatNumber'] = $order_info['fields'][$vat_number];
	}
	
	$k = 0;
	foreach($order_info['products'] as $hash => $p) {
		$post['Items'][$k] = array(
			'Id' => 0,
			'CatalogNumber' => $p['product_code'],
			'UnitPrice' => $p['price'],
			'Quantity' => $p['amount'],
			'Description' => $p['product']
		);
		++$k;
	}
	
	$data = json_encode($post);

	$return = Http::post($url, $data, array(
		'headers' => array(
			'Content-Type: application/json'
		)
	));
	$return = json_decode($return, true);

	if (isset($return['Status']) && empty($return['Status']) && !empty($return['URL'])) {
		fn_redirect($return['URL'], true);
	} else {
		$pp_response = array(
			'status' => 'F',
			'reason_text' => $return
		);
		fn_finish_payment($order_id, $pp_response);
	}
}
